Unit ev01r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTEV10_p;

procedure ev01r(var A :Array of Real; var F :Array of Real; N :Integer;
                L :Integer; ALFA :Real; H :Real; var B :Array of Real;
                var C :Array of Real; var U :Array of Real;
                var IERR :Integer);

implementation

procedure ev01r(var A :Array of Real; var F :Array of Real; N :Integer;
                L :Integer; ALFA :Real; H :Real; var B :Array of Real;
                var C :Array of Real; var U :Array of Real;
                var IERR :Integer);
var
I,IND,IND1,IND2,J,M,N1,N2,N3,N4 :Integer;
R,R1,R2,R3,RAB,RC,RS,S :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120;
begin
{       }
{      . }
{    . }
{       }
N2 := Trunc( N/2 );
A[0] := A[0]*H/2.0;
A[N-1] := A[N-1]*H/2.0;
N1 := N - 1;
for I:=2 to N1 do
 begin
  A[I-1] := A[I-1]*H;
_10:
 end;
if ( L = 0 ) 
 then goto _20;
{  L-  : }
{  L=0,   , }
{  L=1,   . }
for I:=1 to N2 do
 begin
  J := N + 1 - I;
  R := F[J-1];
  F[J-1] := F[I-1];
  F[I-1] := R;
_20:
 end;
N1 := 1;
M := 0;
for I:=1 to N do
 begin
  C[I-1] := 0.0;
  IND := I + N;
  F[IND-1] := 0.0;
_30:
 end;
{   Q-R  , }
{   . }
C[0] := Sqrt(ALFA)/H;
C[1] := -C[0];
for I:=1 to N do
 begin
  R1 := Sqrt(A[I-1]*A[I-1] + C[I-1]*C[I-1]);
  if ( R1 <> 0. ) 
   then goto _40;
  RC := 1.0;
  RS := 0.0;
  goto _50;
_40:
  RC := A[I-1]/R1;
  RS := -C[I-1]/R1;
_50:
  for J:=N1 to N do
   begin
    IND1 := N + J + 1 - N1;
    IND2 := M + J;
    R1 := A[J-1];
    R2 := C[J-1];
    if ( J > N1 ) 
     then A[J-1] := R3;
    R3 := RC*R1 - RS*R2;
    B[IND2-1] := R3;
    if ( J > N1 ) 
     then C[J-1] := RS*R1 + RC*R2;
    RAB := F[J-1];
    F[J-1] := RC*RAB - RS*F[IND1-1];
    F[IND1-1] := RS*RAB + RC*F[IND1-1];
_60:
   end;
  M := M + N - N1;
  N1 := N1 + 1;
_70:
 end;
{      }
{    . }
IERR := 0;
M := Trunc( N*(N + 1)/2 );
if ( B[M-1] = 0. ) 
 then goto _100;
U[N-1] := F[N-1]/B[M-1];
if ( N = 1 ) 
 then goto _110;
M := M - 1;
N1 := N - 1;
for I:=1 to N1 do
 begin
  S := 0.0;
  N2 := N - I + 1;
  for J:=N2 to N do
   begin
    N3 := N - J + N2;
    S := S + U[N3-1]*B[M-1];
    M := M - 1;
_80:
   end;
  if ( B[M-1] = 0. ) 
   then goto _100;
  N4 := N - I;
  U[N4-1] := (F[N4-1] - S)/B[M-1];
  M := M - 1;
_90:
 end;
goto _110;
_100:
IERR := 65;
UTEV10(IERR,1);
_110:
if ( L = 0 ) 
 then goto _120;
N2 := Trunc( N/2 );
for I:=1 to N2 do
 begin
  J := N + 1 - I;
  R := U[J-1];
  U[J-1] := U[I-1];
  U[I-1] := R;
_120:
 end;
end;

end.
